[//]: # "Title: Projects - sapphirus.org"
[//]: # "Summary: Projects I've worked on over the past while."
[//]: # "Copyright (C) 2024-2025 Xavier Moffett
         All Rights Reserved"

# Projects

## Software

These are software projects I've developed to one degree or another over the past while. Preferred language of choice 
right now is Rust, although you'll find other languages mixed within these projects.

The source code for these projects, most of which are open source, are available both on Github and mirrored on my 
self-hosted [code forge](https://git.sapphirus.org).

### pacwrap ([Github](https://github.com/pacwrap)) ([Mirror](https://git.sapphirus.org/pacwrap))
 
A package management front-end which utilises libalpm to facilitate the creation of unprivileged, userspace containers 
with parallelised, filesystem-agnostic deduplication. These containers are constructed via bubblewrap to execute package 
transactions and launch applications.

### Uketoru ([Github](https://github.com/SapphirusBeryl/Uketoru)) ([Mirror](https://git.sapphirus.org/Sapphirus/Uketoru))

Simple, yet configurable middleware to relay messages to a SMTP server.

Making use of the axum and lettre libraries, it provides a lightweight microservice for use as a basic message relay.

### SimpleByteUnit ([Github](https://github.com/SapphirusBeryl/simplebyteunit)) ([Mirror](https://git.sapphirus.org/Sapphirus/simplebyteunit))

SimpleByteUnit is a crate which provides a thin encapsulate for integer primitives to facilitate a fast, simple, yet ergonomic byteunit implementation.

Utilising Rust's sum type, it provides a simple way to convert integers into human-readable byteunits.

### Window Controls Applet ([Github](https://github.com/SapphirusBeryl/window-controls-applet)) ([Mirror](https://git.sapphirus.org/Sapphirus/window-controls-applet))

Provides a themable window control applet for the Cinnamon Desktop Environment.

Motivation for this project was to have a usable desktop environment whilst maximising screen real estate.

## Work in progress

Some projects of mine that are currently a _work in progress_, so they may not be publicly available yet.

### Static Website Generator

Used to generate this website with 🦀. More coming on this soon™.

These hypertext documents were derived from version-controlled Markdown and HTML documents. Each document is made source available&nbsp;
[here](https://git.sapphirus.org/sapphirus.org/website), along with the commit and its parent tagged in the footer of each page.

## Miscellaneous

Here are some miscellaneous projects, software or otherwise, that don't quite fit in any other category.

### Dotfiles ([Github](https://github.com/SapphirusBeryl/dotfiles)) ([Mirror](https://git.sapphirus.org/Sapphirus/dotfiles))

A collection of the dotfiles I use to be productive in my daily work.

### Package Maintenance

I'm presently the maintainer of the following [AUR](https://git.sapphirus.org/AUR) packages:

- #### opencubicplayer
- #### libancient
- #### pacwrap
